
!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/24/2011 00:29'!
acessesToCV: classVarName from: aClass
	
	^(SystemNavigation default) allCallsOn: (aClass classPool associationAt: classVarName )
! !

!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/24/2011 00:26'!
acessesToIV: instVarName from: aClass
	| coll |
	coll := OrderedCollection new.
	aClass
		withAllSubAndSuperclassesDo: [ :class | 
			(class whichSelectorsAccess: instVarName)
				do: [ :sel | 
					sel isDoIt
						ifFalse: [ coll add: (SourcedMethodReference new setClass: class methodSymbol: sel) ] ] ].
	^ coll! !

!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/24/2011 00:44'!
classDefinitionTemplate: classTemplateType
	| stream |
	classTemplateType == #new
		ifTrue: [ ^ Class templateForSubclassOf: Object name category: self theClass theNonMetaClass category ].

	classTemplateType == #subclass
		ifTrue: [ ^ Class templateForSubclassOf: self theClass name category: self theClass theNonMetaClass category ].
		
	"classTemplateType == #definition"
	stream := WriteStream on: String new.
	stream
		nextPutAll: self theClass definition;
		nextPut: $.;
		cr;
		cr;
		nextPutAll: self theClass class definition;
		nextPut: $.;
		cr.
	^ stream contents! !

!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/23/2011 20:43'!
copyClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/23/2011 20:43'!
removeClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/23/2011 20:43'!
renameClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-pharo-views' stamp: 'dkh 5/24/2011 01:06'!
renderClassExplorerOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			html break.
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: self theClass superclass allCallsOn.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass superclass name ]
				on: html.
			html text: ' subclass: '.
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: self theClass allCallsOn.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name ]
				on: html.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace push: (self acessesToIV: iv from: self theClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'classVariableNames: '.
					self theClass classVarNames
						do: [ :cv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace push: (self acessesToCV: cv from: self theClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: cv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'poolDictionaries: '.
					self theClass theNonMetaClass poolDictionaryNames
						do: [ :sp | 
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace
										push:
											(SystemNavigation default allReferencesToPool: (Smalltalk globals at: sp asSymbol) from: self theClass theNonMetaClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: sp ]
								on: html ] ].
			html
				unorderedList: [ 
					| cat |
					html text: 'category: '.
					cat := self theClass theNonMetaClass category.
					self
						renderLink: [ :s | 
							| frame |
							frame := main currentSpace push: (SystemOrganization classesInCategory: cat).
							frame selectedCenterTab: #inspect.
							main updateCenterSideHistory: s ]
						with: [ html strong: cat ]
						on: html ].
			html break.
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: self theClass class allCallsOn.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name , ' class' ]
				on: html.
			html break.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass class instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace push: (self acessesToIV: iv from: self theClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ] ]
		on: html! !
